      PROGRAM TESTS
      INCLUDE 'mpif.h'
      INCLUDE 'mpxf.h'
C
C Tests for MPX functions
C
      INTEGER IERROR, NEWCOMM, NPROC, MYID
C-----------------------------------------------------------------------
C Initialization of MPX
      CALL MPX_Init(MPX_ERRORS_ARE_FATAL, IERROR)
      IF(IERROR .NE. MPX_SUCCESS) THEN
         PRINT *, 'ERROR IN MPX_Init'
      END IF
C
      NPROC = MPX_NProc(MPX_COMM_WORLD, IERROR)
      MYID = MPX_MyId(MPX_COMM_WORLD, IERROR)
      PRINT *, 'NPROC = ', NPROC, ' MYID = ', MYID
C
      IF(NPROC .LT. 4) THEN
         CALL MPX_BARRIER(COMM, IERROR)
         IF(MYID .EQ. 0) PRINT *, 'MUST BE AT LEAST 4 PROCESSES'
         CALL MPX_Finalize(IERROR)
         IF(IERROR .NE. MPX_SUCCESS) THEN
            IF(MYID .EQ. 0) PRINT *, 'ERROR IN MPX_Finalize'
         END IF
	 STOP
      END IF
C
      IF(NPROC .LT. 16) THEN
         CALL TEST(MPX_COMM_WORLD)
      ELSE
         COLOR = NPROC
         KEY = MYID
         CALL MPX_COMM_SPLIT(COMM, COLOR, KEY, NEWCOMM, IERROR)
         IF(IERROR .NE. MPX_SUCCESS) THEN
            PRINT *, 'ERROR IN MPX_COMM_Split'
         END IF
c      IF(MYID .EQ. 0) THEN
c         IF(NEWCOMM .NE. COMM .AND. NEWCOMM .NE.
c     &      MPX_COMM_NULL) THEN
c            PRINT *, '7.3. MPX_COMM_SPLIT --- OK'
c         ELSE
c            PRINT *, '7.3. MPX_COMM_SPLIT --- ERROR'
c         ENDIF
c      END IF
c      CALL MPX_COMM_FREE(NEWCOMM, IERROR)
c      IF(IERROR .NE. MPX_SUCCESS) THEN
c         PRINT *, 'ERROR IN MPX_COMM_FREE'
c      END IF
c      IF(MYID .EQ. 0) THEN
c            PRINT *, '7.4. MPX_COMM_FREE --- OK'
c      END IF
C
      END IF
C
      CALL STATISTIC()
C-----------------------------------------------------------------------
C Finalization of MPX
      CALL MPX_Finalize(IERROR)
      IF(IERROR .NE. MPX_SUCCESS) THEN
         PRINT *, 'ERROR IN MPX_Finalize'
      END IF
C
      END
C
      SUBROUTINE TEST(COMM)
      INCLUDE 'mpif.h'
      INCLUDE 'mpxf.h'
C
C Tests for MPX functions
C
      INTEGER NTIMES, SIZE
      PARAMETER (NTIMES = 10000, NTIMES_PREC=100000,SIZE = 100000)
      INTEGER NPROC, MYID, I, REQUEST, RES, IDCART, COORD(256),
     *        DIMS(256), CARTMYID, REQUESTS(256), COORD1(256), TYPE1,
     *        RANK, ISIZE, COLOR, KEY, NEWCOMM
      DOUBLE PRECISION T1, T2, T, TT, DT, LAT, TB
      INTEGER BUF(SIZE), OBUF(SIZE)
      INTEGER STATUS(MPX_STATUS_SIZE), STATUSES(MPX_STATUS_SIZE, 16)
      INTEGER IERROR
      LOGICAL LOG, PERIODS(256), FLAG
C-----------------------------------------------------------------------
C Detection of constants
      NPROC = MPX_NProc(COMM, IERROR)
      IF(IERROR .NE. MPX_SUCCESS) THEN
         PRINT *, 'ERROR IN MPX_NProc'
      END IF
      MYID = MPX_MyId(COMM, IERROR)
      IF(IERROR .NE. MPX_SUCCESS) THEN
         IF(MYID .EQ. 0) PRINT *, 'ERROR IN MPX_MyId'
      END IF
C      PRINT *, 'NPROC = ', NPROC, ' MYID = ', MYID
      IF(NPROC .LT. 4) THEN
         CALL MPX_BARRIER(COMM, IERROR)
         IF(MYID .EQ. 0) PRINT *, 'MUST BE AT LEAST 4 PROCESSES'
         CALL MPX_Finalize(IERROR)
         IF(IERROR .NE. MPX_SUCCESS) THEN
            IF(MYID .EQ. 0) PRINT *, 'ERROR IN MPX_Finalize'
         END IF
	 RETURN
      END IF
C-----------------------------------------------------------------------
C
      CALL MPX_BARRIER(COMM, IERROR)
      IF(IERROR .NE. MPX_SUCCESS) THEN
         IF(MYID .EQ. 0) PRINT *, 'ERROR IN MPX_BARRIER'
      END IF
      DT = 0
      DO I = 1, NTIMES_PREC
         T1 = MPX_WTIME()
         T2 = MPX_WTIME()
         DT = DT + T2 - T1
      END DO
      DT = DT / NTIMES_PREC
C-----------------------------------------------------------------------
C Initialization of arrays
      DO I = 1, SIZE
         BUF(I) = MYID
      END DO
C-----------------------------------------------------------------------
C Detection of parameters
      CALL MPX_BARRIER(COMM, IERROR)
      IF(IERROR .NE. MPX_SUCCESS) THEN
         IF(MYID .EQ. 0) PRINT *, 'ERROR IN MPX_BARRIER'
      END IF
      IF(MYID .EQ. 0) THEN
         PRINT *, '----------------------------------------------------'
         PRINT *, 'DETECTION OF PARAMETERS'
      END IF
 111  FORMAT(A,T30,E10.5)
C
      IF(MYID .EQ. 0) PRINT 111, ' TIME CALCULATION = ', DT
C
      TB = 0
      DO I = 1, NTIMES_PREC
         CALL MPX_BARRIER(COMM, IERROR)
         T1 = MPX_WTIME()
         CALL MPX_BARRIER(COMM, IERROR)
         T2 = MPX_WTIME()
         TB = TB + T2 - T1 - DT
      END DO
      TB = TB / NTIMES_PREC
      IF(MYID .EQ. 0) PRINT 111, ' BARRIER = ', T
C
      T = 0
      DO I = 1, NTIMES
         CALL MPX_BARRIER(COMM, IERROR)
         T1 = MPX_WTIME()
         CALL MPX_AllReduce(BUF, OBUF, 1, MPX_INTEGER, MPX_SUM,
     *                      COMM, IERROR)
         CALL MPX_BARRIER(COMM, IERROR)
         T2 = MPX_WTIME()
         T = T + T2 - T1 - DT - TB
      END DO
      T = T / NTIMES
      IF(MYID .EQ. 0) PRINT 111, ' GLOBAL SUM(ALLREDUCE) = ', T
C
      T = 0
      DO I = 1, NTIMES
         CALL MPX_BARRIER(COMM, IERROR)
         T1 = MPX_WTIME()
         CALL MPX_AllReduce(BUF, OBUF, 10, MPX_INTEGER, MPX_SUM,
     *                      COMM, IERROR)
         CALL MPX_BARRIER(COMM, IERROR)
         T2 = MPX_WTIME()
         T = T + T2 - T1 - DT - TB
      END DO
      T = T / NTIMES
      IF(MYID .EQ. 0) PRINT 111, ' 10 GLOBAL SUMS(ALLREDUCE) = ', T
C
      T = 0
      DO I = 1, NTIMES
         CALL MPX_BARRIER(COMM, IERROR)
         T1 = MPX_WTIME()
         CALL MPX_Reduce(BUF, OBUF, 1, MPX_INTEGER, MPX_SUM, 0,
     *                      COMM, IERROR)
         CALL MPX_BARRIER(COMM, IERROR)
         T2 = MPX_WTIME()
         T = T + T2 - T1 - DT - TB
      END DO
      T = T / NTIMES
      IF(MYID .EQ. 0) PRINT 111, ' GLOBAL SUM(REDUCE) = ', T
C
      T = 0
      DO I = 1, NTIMES
         CALL MPX_BARRIER(COMM, IERROR)
         T1 = MPX_WTIME()
         CALL MPX_Reduce(BUF, OBUF, 10, MPX_INTEGER, MPX_SUM, 0,
     *                      COMM, IERROR)
         CALL MPX_BARRIER(COMM, IERROR)
         T2 = MPX_WTIME()
         T = T + T2 - T1 - DT - TB
      END DO
      T = T / NTIMES
      IF(MYID .EQ. 0) PRINT 111, ' 10 GLOBAL SUMS(REDUCE) = ', T
C
      T = 0
      DO I = 1, NTIMES
         CALL MPX_BARRIER(COMM, IERROR)
         T1 = MPX_WTIME()
         CALL MPX_Bcast(BUF, 1, MPX_INTEGER, 1, COMM, IERROR)
         CALL MPX_BARRIER(COMM, IERROR)
         T2 = MPX_WTIME()
         T = T + T2 - T1 - DT - TB
      END DO
      T = T / NTIMES
      IF(MYID .EQ. 0) PRINT 111, ' BCAST = ', T
C
      T = 0
      DO I = 1, NTIMES
         CALL MPX_BARRIER(COMM, IERROR)
         T1 = MPX_WTIME()
         CALL MPX_Gather(BUF, 1, MPX_INTEGER, OBUF, 0, COMM,
     *                   IERROR)
         CALL MPX_BARRIER(COMM, IERROR)
         T2 = MPX_WTIME()
         T = T + T2 - T1 - DT - TB
      END DO
      T = T / NTIMES
      IF(MYID .EQ. 0) PRINT 111, ' GATHER = ', T
C
      IF(MYID .EQ. 0) THEN
         T = 0
         DO I = 1, NTIMES
            T1 = MPX_WTIME()
            CALL MPX_ISend(BUF, 10, MPX_INTEGER, 1, 2, COMM,
     *                     REQUEST, IERROR)
            T2 = MPX_WTIME()
            T = T + T2 - T1 - DT
         END DO
         T = T / NTIMES
         PRINT 111, ' NONBLOCKING SEND = ', T
         T = 0
         DO I = 1, NTIMES
            T1 = MPX_WTIME()
            CALL MPX_IProbe(0, 2, COMM, FLAG, STATUS, IERROR)
            T2 = MPX_WTIME()
            T = T + T2 - T1 - DT
         END DO
         T = T / NTIMES
         PRINT 111, ' IProbe = ', T
      END IF
      IF(MYID .EQ. 1) THEN
         DO I = 1, NTIMES
            CALL MPX_IRecv(OBUF, 10, MPX_INTEGER, 0, 2,
     *                        COMM, REQUEST, IERROR)
            CALL MPX_Wait(REQUEST, STATUS, IERROR)
         END DO
      END IF
C
 112  FORMAT(A,T30,E10.5)
      CALL MPX_BARRIER(COMM, IERROR)
      IF(MYID .EQ. 0) THEN
         T = 0
         DO I = 1, NTIMES
            T1 = MPX_WTIME()
            CALL MPX_ISend(BUF, 10, MPX_INTEGER, 1, 2, COMM,
     *                     REQUEST, IERROR)
            CALL MPX_WAIT(REQUEST, STSTUS, IERROR)
            T2 = MPX_WTIME()
            T = T + T2 - T1 - DT
         END DO
         T = T / NTIMES
         PRINT 112, ' NONBLOCKING SEND & WAIT = ', T
      END IF
      IF(MYID .EQ. 1) THEN
         DO I = 1, NTIMES
            CALL MPX_IRecv(OBUF, 10, MPX_INTEGER, 0, 2,
     *                        COMM, REQUEST, IERROR)
            CALL MPX_Wait(REQUEST, STATUS, IERROR)
         END DO
      END IF
C
      CALL MPX_BARRIER(COMM, IERROR)
      IF(MYID .EQ. 0) THEN
         T = 0
         DO I = 1, NTIMES
            T1 = MPX_WTIME()
            CALL MPX_Send(BUF, 1, MPX_INTEGER, 1, 0, COMM,
     *                    IERROR)
            T2 = MPX_WTIME()
            T = T + T2 - T1 - DT
         END DO
         T = T / NTIMES
         PRINT 112, ' BLOCKING SEND = ', T
      END IF
      IF(MYID .EQ. 1) THEN
         DO I = 1, NTIMES
            CALL MPX_Recv(OBUF, 1, MPX_INTEGER, 0, 0, COMM,
     *                    STATUS, IERROR)
         END DO
      END IF
C
      CALL MPX_BARRIER(COMM, IERROR)
      IF(MYID .EQ. 0) THEN
         T = 0
         DO I = 1, NTIMES
            T1 = MPX_WTIME()
            CALL MPX_SendRecv(BUF, 1, MPX_INTEGER, 1, MYID,
     *                        OBUF, 1, MPX_INTEGER, 1, 1,
     *                        COMM, STATUS, IERROR)
            T2 = MPX_WTIME()
            T = T + T2 - T1 - DT
         END DO
         T = T / NTIMES
         PRINT 112, ' SENDRECV = ', T
      END IF
      IF(MYID .EQ. 1) THEN
         DO I = 1, NTIMES
            CALL MPX_SendRecv(BUF, 1, MPX_INTEGER, 0, MYID,
     *                        OBUF, 1, MPX_INTEGER, 0, 0,
     *                        COMM, STATUS, IERROR)
         END DO
      END IF
C
      CALL MPX_BARRIER(COMM, IERROR)
      IF(MYID .EQ. 0) THEN
         T = 0
         DO I = 1, NTIMES
            T1 = MPX_WTIME()
            CALL MPX_Send(BUF, 1, MPX_INTEGER, 1, 0, COMM,
     *                    IERROR)
            CALL MPX_Recv(OBUF, 1, MPX_INTEGER, 1, 1, COMM,
     *                    STATUS, IERROR)
            T2 = MPX_WTIME()
            T = T + T2 - T1 - DT
         END DO
         T = T / NTIMES
         PRINT 112, ' SEND & RECV = ', T
      END IF
      IF(MYID .EQ. 1) THEN
         DO I = 1, NTIMES
            CALL MPX_Recv(OBUF, 1, MPX_INTEGER, 0, 0, COMM,
     *                    STATUS, IERROR)
            CALL MPX_Send(BUF, 1, MPX_INTEGER, 0, 1, COMM,
     *                    IERROR)
         END DO
      END IF
C
      CALL MPX_BARRIER(COMM, IERROR)
      IF(MYID .EQ. 0) THEN
         T = 0
         DO I = 1, NTIMES
            T1 = MPX_WTIME()
            CALL MPX_Send_Init(BUF, 1, MPX_INTEGER, 1, 17, COMM,
     *                         REQUESTS(1), IERROR)
            CALL MPX_Send_Init(BUF, 1, MPX_INTEGER, 1, 17, COMM,
     *                         REQUESTS(2), IERROR)
            CALL MPX_Send_Init(BUF, 1, MPX_INTEGER, 1, 17, COMM,
     *                         REQUESTS(3), IERROR)
            CALL MPX_Send_Init(BUF, 1, MPX_INTEGER, 1, 17, COMM,
     *                         REQUESTS(4), IERROR)
            CALL MPX_Send_Init(BUF, 1, MPX_INTEGER, 1, 17, COMM,
     *                         REQUESTS(5), IERROR)
            CALL MPX_StartAll(5, REQUESTS, IERROR)
            CALL MPX_WaitAll(5, REQUESTS, STATUSES, IERROR)
            T2 = MPX_WTIME()
            T = T + T2 - T1 - DT
         END DO
         T = T / NTIMES
         PRINT 112, ' 5 SENDS IN ONE = ', T
      END IF
      IF(MYID .EQ. 1) THEN
         DO I = 1, NTIMES
            CALL MPX_Recv_Init(OBUF, 1, MPX_INTEGER, 0, 17,
     *                         COMM, REQUESTS(1), IERROR)
            CALL MPX_Recv_Init(OBUF(2), 1, MPX_INTEGER, 0, 17,
     *                         COMM, REQUESTS(2), IERROR)
            CALL MPX_Recv_Init(OBUF(3), 1, MPX_INTEGER, 0, 17,
     *                         COMM, REQUESTS(3), IERROR)
            CALL MPX_Recv_Init(OBUF(4), 1, MPX_INTEGER, 0, 17,
     *                         COMM, REQUESTS(4), IERROR)
            CALL MPX_Recv_Init(OBUF(5), 1, MPX_INTEGER, 0, 17,
     *                         COMM, REQUESTS(5), IERROR)
            CALL MPX_StartAll(5, REQUESTS, IERROR)
            CALL MPX_WaitAll(5, REQUESTS, STATUSES, IERROR)
         END DO
      END IF
C
      CALL MPX_BARRIER(COMM, IERROR)
      IF(MYID .EQ. 0) THEN
         T = 0
         DO I = 1, NTIMES
            T1 = MPX_WTIME()
            CALL MPX_ISend(BUF, 1, MPX_INTEGER, 1, 17, COMM,
     *                         REQUESTS(1), IERROR)
            CALL MPX_ISend(BUF, 1, MPX_INTEGER, 1, 17, COMM,
     *                         REQUESTS(2), IERROR)
            CALL MPX_ISend(BUF, 1, MPX_INTEGER, 1, 17, COMM,
     *                         REQUESTS(3), IERROR)
            CALL MPX_ISend(BUF, 1, MPX_INTEGER, 1, 17, COMM,
     *                         REQUESTS(4), IERROR)
            CALL MPX_ISend(BUF, 1, MPX_INTEGER, 1, 17, COMM,
     *                         REQUESTS(5), IERROR)
            CALL MPX_WaitAll(5, REQUESTS, STATUSES, IERROR)
            T2 = MPX_WTIME()
            T = T + T2 - T1 - DT
         END DO
         T = T / NTIMES
         PRINT 112, ' 5 SENDS = ', T
      END IF
      IF(MYID .EQ. 1) THEN
         DO I = 1, NTIMES
            CALL MPX_Recv_Init(OBUF, 1, MPX_INTEGER, 0, 17,
     *                         COMM, REQUESTS(1), IERROR)
            CALL MPX_Recv_Init(OBUF(2), 1, MPX_INTEGER, 0, 17,
     *                         COMM, REQUESTS(2), IERROR)
            CALL MPX_Recv_Init(OBUF(3), 1, MPX_INTEGER, 0, 17,
     *                         COMM, REQUESTS(3), IERROR)
            CALL MPX_Recv_Init(OBUF(4), 1, MPX_INTEGER, 0, 17,
     *                         COMM, REQUESTS(4), IERROR)
            CALL MPX_Recv_Init(OBUF(5), 1, MPX_INTEGER, 0, 17,
     *                         COMM, REQUESTS(5), IERROR)
            CALL MPX_StartAll(5, REQUESTS, IERROR)
            CALL MPX_WaitAll(5, REQUESTS, STATUSES, IERROR)
         END DO
      END IF
C
      CALL MPX_BARRIER(COMM, IERROR)
      IF(MYID .EQ. 0) THEN
         T = 0
         DO I = 1, NTIMES
            T1 = MPX_WTIME()
            CALL MPX_Sig_Send(1, I, COMM, IERROR)
            CALL MPX_Sig_Wait(1, I, COMM, IERROR)
            T2 = MPX_WTIME()
            T = T + T2 - T1 - DT
         END DO
         T = T / NTIMES / 2
         PRINT 112, ' SIGNAL SENDING = ', T
      END IF
      IF(MYID .EQ. 1) THEN
         DO I = 1, NTIMES
            CALL MPX_Sig_Wait(0, I, COMM, IERROR)
            CALL MPX_Sig_Send(0, I, COMM, IERROR)
         END DO
      END IF
C
      CALL MPX_BARRIER(COMM, IERROR)
      IF(MYID .EQ. 0) THEN
         T = 0
         DO I = 1, NTIMES
            T1 = MPX_WTIME()
            CALL MPX_Send(BUF, 0, MPX_INTEGER, 1, I+1, COMM,
     *                    IERROR)
            CALL MPX_Recv(OBUF, 0, MPX_INTEGER, 1, I+1, COMM,
     *                    STATUS, IERROR)
            T2 = MPX_WTIME()
            T = T + T2 - T1 - DT
         END DO
         LAT = T / NTIMES / 2
         PRINT 112, ' LATENCY = ', LAT
      END IF
      IF(MYID .EQ. 1) THEN
         DO I = 1, NTIMES
            CALL MPX_Recv(OBUF, 0, MPX_INTEGER, 0, I+1, COMM,
     *                    STATUS, IERROR)
            CALL MPX_Send(BUF, 0, MPX_INTEGER, 0, I+1, COMM,
     *                    IERROR)
         END DO
      END IF
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE STATISTIC()
      INCLUDE 'mpif.h'
      INCLUDE 'mpxf.h'
C
      INTEGER IERROR
      INTEGER MYID, NPROC
      INTEGER LENGTH, COUNT
      DOUBLE PRECISION TIME
      INTEGER STATUS(MPX_STATUS_SIZE)
C
      CALL MPX_BARRIER(MPX_COMM_WORLD, IERROR)
      MYID = MPX_MYID(MPX_COMM_WORLD, IERROR)
      NPROC = MPX_NPROC(MPX_COMM_WORLD, IERROR)
      CALL MPX_STATISTICS(COUNT, LENGTH, TIME)
      IF(MYID .NE. 0) THEN
         CALL MPX_SEND(LENGTH, 1, MPX_INTEGER, 0, 1,
     *                 MPX_COMM_WORLD, IERROR)
         CALL MPX_SEND(COUNT, 1, MPX_INTEGER, 0, 2,
     *                 MPX_COMM_WORLD, IERROR)
         CALL MPX_SEND(TIME, 1, MPX_DOUBLE_PRECISION, 0, 3,
     *                 MPX_COMM_WORLD, IERROR)
      END IF
C
      RETURN
      END
C----------------------------------------------------------------------
